#pragma once

#include "DTVCapture/DTV_EzUsbfx2.h"
#include "DTVCapture/DTV_Friio.h"
#include "DTVCapture/DTV_OptCUSB2.h"
#include "DTVCapture/DTV_FileIn.h"
#include "Common/Buffer.h"
#include "Common/FileRecord.h"
#include "Common/NetworkSend.h"
#include "Common/DateTime.h"
#include "TsStreamEngine/TsStream.h"
#include "FilterWnd.h"
#include "ChannelWnd.h"
#include "ScheduleRec.h"

#include <map>
#include <set>

// fobOrh̃G[R[ho
#ifdef _DEBUG
#define CATCH_INT_ERROR_CODE(err_code) {char err_buf[255];wsprintf(err_buf,"%s() errcode=%d\n",__FUNCTION__,err_code);OutputDebugString(err_buf);}
#else
#define CATCH_INT_ERROR_CODE(err_code) {err_code=err_code;/*rhwarningp_~[*/}
#endif

#define CAPUSB_OPTION_FILENAME		"capusb.ini"
#define CAPUSB_SCHEDULE_FILENAME	"schedule.ini"

#define ENABLE_ARIB_B25_PROC						// B-Cas cardɂARIB-B25fR[hs(B25Decorder.dll)

#define ASYNC_XFER_REQ_NUM		32					// 񓯊]L[̍ől(傫Γ˔IȃhbvɑΏ\Bx͂邾낤)
#define ASYNC_XFER_SIZE			0x8000				// 񓯊]TCY
													// 悭Xbh΁A ASYNC_XFER_REQ_NUMxASYNC_XFER_SIZE̎Mҋ@obt@mۂł
													// ҋ@obt@Pl΁A0.1~0.2bقǂ̓}[WłƂ͎vB

#define RECORD_WARNING_DISK_FREE	(ULONGLONG)1000*1024*1024	// fBXNeʃG[Ōxoce
#define RECORD_STOP_DISK_FREE		(ULONGLONG)200*1024*1024	// fBXNeʃG[Ř^~ce

#define REDRAWTIME_XFER_RESULT	300				// ]ʕ\Ԋu
#define CALCTIME_XFER_SPEED		600				// ]xvZԊu

#define FILE_WRITE_BLOCK_SIZE	1*1024*1024			// t@Cރf[^P(0Ȃ璼)
													// lbg[NɏޏꍇAw肵ق
													// [JfBXNȂ0ŏ[


// IvV
struct CapUSB_Option
{
	BOOL	bHvMikittyInit;
	BOOL	bARIB_B25;
	BOOL	bAutoFilename;
	char	szAutoPath[MAX_PATH];

	int		iTimerPeriod;
	int		iThreadPriorityReq;
	int		iThreadPriorityRes;
	int		iThreadPriorityProc;

	int		iLastInEP;
	int		iLastOutEP;

	int		iRecTime;
	
	char	szNetworkAddress[MAX_PATH];
	int		iNetworkPort;
	int		iNetworkSendSize;

	int		iPosX,iPosY;
	BOOL	bShowChWnd;
	int		iChPosX,iChPosY;
	int		iLastSelCh;

	BOOL	bShowFiltWnd;
	int		iFiltPosX,iFiltPosY;
	int		iFiltSizeX,iFiltSizeY;

	BOOL	bShowScheduleWnd;
	int		iSchePosX,iSchePosY;
	int		iScheSizeX,iScheSizeY;

	BOOL	bNoRejectNullPacket;

	BOOL	bDecodePSI;
	BOOL	bProcEPG;

	BOOL	bUseSystemTime;
};

typedef std::map<WORD,struct TSServiceList*> ServiceListMap;
typedef std::pair<WORD,struct TSServiceList*> ServiceListPair;

struct TSServiceList
{
	int iItemPos;	
	WORD wPmtPID;
	char szServiceName[20];

	BYTE byCurrentEventType;
	BYTE byCurrentEventVer;
	WORD wCurrentEventID;

	std::vector<WORD> PIDs;
};

// 񓯊]L[
struct AsyncXferRequest
{
	OVERLAPPED		Overlap;
	CCyUSBEndPoint	*pEndPoint;
	PUCHAR			pContext;

	BYTE buf[ASYNC_XFER_SIZE];
	LONG buf_len; 
};

struct ThreadInfo
{
	HANDLE	hThread;
	DWORD	dwThreadID;
	HANDLE	hExitEvent;
};

struct StreamProcThreadParam
{
	LPVOID			lpClassPtr;
	CB25			*pB25;
};

class CMMTimerPeriod
{
public:
	CMMTimerPeriod(UINT uPeriod,int init_error_throw_val)
	{
		m_uPeriod=uPeriod;
		if(TIMERR_NOERROR!=timeBeginPeriod(m_uPeriod))
		{
			throw init_error_throw_val;
		}
	}
	~CMMTimerPeriod()
	{
		timeEndPeriod(m_uPeriod);
	}
protected:
	UINT m_uPeriod;
};

class CCapUSB_Main
{
public:
	CCapUSB_Main();
	~CCapUSB_Main(void);
	int Main(HINSTANCE hInstance);

protected:
	HINSTANCE m_hInst;
	HWND m_hWnd;
	HWND m_hStatusBar;
	CDTV_Base *m_pDTV;						// DTVNX|C^
	
	BOOL				m_bDeviceConnect;
	BOOL				m_bThreadActive;
	BOOL				m_bPacketFilter;
	CMMTimerPeriod*		m_pMMTimerPeriod;
	struct ThreadInfo	m_stStreamProc;		// Xg[

	CRITICAL_SECTION m_csGUI;				// GUIp
	CRITICAL_SECTION m_csServiceList;		// T[rXXgp

	CBufferMT				*m_pStreamBuf;
	CTsStream				*m_pTsStream;
	struct TS_StreamInfo	m_stStreamInfo;
	CFileRecord				*m_pFileRecord;
	CNetworkSend			*m_pNetworkSend;	
	DWORD					m_dwFileRecEndTick;

	// DialogProc	
	static LRESULT CALLBACK CapUSB_MainDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
	BOOL OnInitDialog();
	BOOL OnCommand(WPARAM wParam,LPARAM lParam);
	BOOL OnUser(WPARAM wParam,LPARAM lParam);
	void OnRefleshBtn();
	void OnSelchangeDeviceListCombox();
	void OnConnect();
	void OnFileRecord(BOOL bForceClose=FALSE);
	void OnNetworkSend(BOOL bForceClose=FALSE);	
	void OnDrawXferResult(struct TS_StreamInfo *lpstStremInfo);

	// `lݒp
	void OnChannel();
	CChannelWnd *m_pChannelWnd;

	// tB^p
	void OnFilter();
	void OnPacketFilter(BOOL bForceDelete=FALSE);
	CFilterWnd	*m_pFilterWnd;
	static BOOL CALLBACK OnGetServiceName(WORD wServiceID,char *lpszBuf,int iBufLen,LPVOID lpContext);
	static void CALLBACK OnSetFilter(WORD *pwDenyServiceList,int iDenyServiceNum,WORD *pwDenyPidList,int iDenyPidNum,LPVOID lpContext);
	static BOOL CALLBACK OnFilterWndEpgRequest(WORD wServiceID,DateTime &stSearchTime,struct TSEPG_PROGRAM *pEpgData,BOOL bDeleteFlg,LPVOID lpContext);
	static BOOL CALLBACK OnFilterWndSetSchduleByTime(WORD wServiceID,DateTime &stStartTime,DWORD dwRecTime,char *lpszName,LPVOID lpContext);
	static BOOL CALLBACK OnFilterWndSetSchduleByEventID(WORD wNetworkID,WORD wStreamID,WORD wServiceID,WORD wEventID,char *lpszName,LPVOID lpContext);

	// ^\p
	WORD m_wTsStreamOutput_Schedule;
	void OnSchedule();
	CScheduleRec *m_pScheduleRec;
	static void CALLBACK OnScheduleSetFilter(BOOL bServiceDenyFlg,WORD *pwSelectService,int iSelectServiceNum,WORD *pwDenyPidList,int iDenyPidNum,LPVOID lpContext);
	static BOOL CALLBACK OnScheduleEpgRequestByID(WORD wNetworkID,WORD wStreamID,WORD wServiceID,WORD wEventID,struct TSEPG_PROGRAM *pEpgData,LPVOID lpContext);

	// fobOp
#ifdef _DEBUG
	static void CALLBACK OnDebugDumpEpgList(WORD wServiceID,char *lpszOutputPath,LPVOID lpContext);
#endif

	// Option
	char m_szOptionFile[MAX_PATH];
	char m_szScheduleFile[MAX_PATH];
	double m_dTimerClock;
	TIMECAPS m_stTimeCaps;
	struct CapUSB_Option m_stOpt;
	BOOL OptionIO(BOOL bSave);
	BOOL CCapUSB_Main::OnOptionDlg();
	static LRESULT CALLBACK CapUSB_OptionDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
	BOOL OnOptionInitDialog(HWND hDlg);
	BOOL GetOptionFromDlg(HWND hDlg,struct CapUSB_Option &stOpt);
	BOOL OnOptionCommand(HWND hDlg,WPARAM wParam,LPARAM lParam);

	// f[^Mp
	static void CALLBACK DTVRecieveCallback(BYTE *pRecvData,DWORD dwRecvSize,unsigned __int64 ui64TotalRecvSize,LPVOID lpContext);
	
	// StreamProc Thread
	static DWORD WINAPI StreamProcThread(LPVOID lpParameter)
	{
		struct StreamProcThreadParam *pStreamProc=(struct StreamProcThreadParam*)lpParameter;
		CCapUSB_Main *pThis=(CCapUSB_Main*)pStreamProc->lpClassPtr;
		return pThis->StreamProcThreadProc(pStreamProc);
	}
	DWORD StreamProcThreadProc(struct StreamProcThreadParam *pStreamProc);
	static void CALLBACK TsCallback(UINT uType,WORD wStreamID,LPVOID pData,DWORD dwVal,LPVOID lpContext);
	void TsCallbackUI(UINT uType,WORD wStreamID,LPVOID pData,DWORD dwVal,LPVOID lpContext);
};
