#pragma once

#include "TsStreamEngine/TsStream.h"
#include "Common/Lock.h"
#include <commctrl.h>
#include <map>
#include <vector>
#include <set>

#define FILTWND_ENABLE_TIPWND			// ToolTipOffɂȂRgAEg
#define FILTWND_ENABLE_CURRENT_PROGRAM	// ݂̔ԑgꗗoffɂȂRgAEg
//#define FILTWND_NOT_CLEAR_PROGRAM_LIST	// Xg[ύXɃvOXgZbgȂRgAEg

#ifdef FILTWND_ENABLE_CURRENT_PROGRAM
	#define SERVICE_DEFAULT_SHOW	// vOꗗD\̂ł΁ARgAEg
#endif

#ifdef FILTWND_ENABLE_TIPWND
	#define FILTWND_TIP_WIDTH			500
	#define FILTWND_TIP_TEXTCOLOR		RGB(0,0,0)
	#define FILTWND_TIP_BGCOLOR			RGB(255,255,200)
	#define FILTWND_TIP_NODATA			""
	#define FILTWND_TIP_MAX_EVENTSTR	1024

	#define FILTWND_TIP_WIDTH_PROG		500
	#define FILTWND_TIP_TEXTCOLOR_PROG	RGB(0,0,0)
	#define FILTWND_TIP_BGCOLOR_PROG	RGB(200,255,255)

	#define FILTWND_TIP_NEXTEVENT	// ݂̎̔ԑg̏擾邩B(RgAEgŎ擾Ȃ)
#endif


#define FILTWND_TAB_SERVICEID		0
#define FILTWND_TAB_CHANNELNAME		1
#define FILTWND_TAB_CURRENTEVENT	2
#define FILTWND_TAB_PMTPID			3
#define FILTWND_TAB_PIDLIST			4

// fbhbNNWindowProcŏ邽߂
#define WM_FILTWND_STATUSRESET				(WM_APP+0x00)
#define WM_FILTWND_DELETEALL				(WM_APP+0x01)
#define WM_FILTWND_ADDITEM					(WM_APP+0x02)
#define WM_FILTWND_SETSUBITEM				(WM_APP+0x03)
#define WM_FILTWND_SETEPG					(WM_APP+0x04)
#ifdef FILTWND_ENABLE_CURRENT_PROGRAM
	#define WM_FILTWND_ADD_PROGRAMITEM		(WM_APP+0x12)
#endif
// TuACe̒ʒm
#define WM_FILTWND_NOTIFYSCROLL				(WM_APP+0x20)
#define WM_FILTWND_NOTIFYMOUSEWHEEL			(WM_APP+0x21)

struct FILTWND_EVENTDATA
{
	// stProgram̂̂g悤ɕύX
	struct TSEPG_PROGRAM stProgram;
};

// Key=T[rXID Val=Data
struct FILTWND_SERVICEDATA
{
	WORD wServiceID;
	WORD wPosition;

	std::vector<WORD> *pPIDs;
	struct FILTWND_EVENTDATA stCurrnetEvent;
#ifdef FILTWND_ENABLE_TIPWND
#ifdef FILTWND_TIP_NEXTEVENT
	struct FILTWND_EVENTDATA stNextEvent;
#endif
	struct
	{
		char szChName[30];
		char szPresentEvent[FILTWND_TIP_MAX_EVENTSTR];
#ifdef FILTWND_TIP_NEXTEVENT
		char szFutureEvent[FILTWND_TIP_MAX_EVENTSTR];
#endif
	} stTipString;
#endif
};

struct FILTWND_PROGRAMLISTDATA
{
	BOOL bUpdateFlg;
	char szChName[30];
	struct TSEPG_PROGRAM stCurrentEvent;
#ifdef FILTWND_TIP_NEXTEVENT
	struct TSEPG_PROGRAM stNextEvent;
#endif
#ifdef FILTWND_ENABLE_TIPWND
	struct
	{
		char szPresentEvent[FILTWND_TIP_MAX_EVENTSTR];
#ifdef FILTWND_TIP_NEXTEVENT
		char szFutureEvent[FILTWND_TIP_MAX_EVENTSTR];
#endif
	} stTipString;
#endif
};

typedef std::map<WORD,FILTWND_SERVICEDATA*>		FiltWndServiceListMap;
typedef std::pair<WORD,FILTWND_SERVICEDATA*>	FiltWndServiceListPair;
#ifdef FILTWND_ENABLE_CURRENT_PROGRAM
typedef std::map<WORD,FILTWND_PROGRAMLISTDATA>	FiltWndProgramListMap;
typedef std::pair<WORD,FILTWND_PROGRAMLISTDATA>	FiltWndProgramListPair;
#endif

// Key=Position Val=T[rXID(tp)
typedef std::map<WORD,WORD>						FiltWndPosToServiceIDMap;
typedef std::pair<WORD,WORD>					FiltWndPosToServiceIDPair;

#ifdef FILTWND_ENABLE_TIPWND
struct FILTWND_TOOLTIP
{
	TOOLINFO stToolTipInfo;
	char szShowString[FILTWND_TIP_MAX_EVENTSTR*2];
};
typedef std::vector<FILTWND_TOOLTIP>	FiltWndToolTip;
#endif

// T[rXvp
typedef BOOL (CALLBACK PF_FILTERWND_GET_SERVICE_NAME)(WORD wServiceID,char *lpszBuf,int iBufLen,LPVOID lpContext);

// pPbgtB^wp
typedef void (CALLBACK PF_FILTERWND_SETFILTER)(WORD *pwDenyServiceList,int iDenyServiceNum,WORD *pwDenyPidList,int iDenyPidNum,LPVOID lpContext);

// ^\vp
typedef BOOL (CALLBACK PF_FILTERWND_SCHEDULE_BYTIME_CALLBACK)(WORD wServiceID,DateTime &stStartTime,DWORD dwRecTime,char *lpszName,LPVOID lpContext);
typedef BOOL (CALLBACK PF_FILTERWND_SCHEDULE_BYEVENTID_CALLBACK)(WORD wNetworkID,WORD wStreamID,WORD wServiceID,WORD wEventID,char *lpszName,LPVOID lpContext);

// fobOp
#ifdef _DEBUG
typedef void (CALLBACK PF_FILTERWND_DEBUG_DUMPEPG_REQUEST_CALLBACK)(WORD wServiceID,char *lpszOutputPath,LPVOID lpContext);
#endif

struct FILTWND_PMTITEM
{
	BYTE	byType;
	WORD	wPID;
};

class CFilterWnd
{
public:
	CFilterWnd(HINSTANCE m_hInst);
	~CFilterWnd(void);

	void Reset()
	{
		PostMessage(m_hWnd,WM_FILTWND_STATUSRESET,0,0);		
	}
	void Set_GetServiceNameCallback(PF_FILTERWND_GET_SERVICE_NAME *lpFunc,LPVOID lpContext)
	{
		m_lpGetServiceNameFunc = lpFunc;
		m_lpGetServiceNameContext = lpContext;
	}
	void SetFilterCallback(PF_FILTERWND_SETFILTER *lpFunc,LPVOID lpContext)
	{
		m_lpSetFilterFunc = lpFunc;
		m_lpSetFilterContext = lpContext;
	}
	void SetScheduleByTimeCallback(PF_FILTERWND_SCHEDULE_BYTIME_CALLBACK *lpFunc,LPVOID lpContext)
	{
		m_lpScheduleTimeFunc = lpFunc;
		m_lpScheduleTimeContext = lpContext;
	}
	void SetScheduleByEventIDCallback(PF_FILTERWND_SCHEDULE_BYEVENTID_CALLBACK *lpFunc,LPVOID lpContext)
	{
		m_lpScheduleEventIDFunc = lpFunc;
		m_lpScheduleEventIDContext = lpContext;
	}
#ifdef _DEBUG
	void SetDebugDumpEpgRequestCallback(PF_FILTERWND_DEBUG_DUMPEPG_REQUEST_CALLBACK *lpFunc,LPVOID lpContext)
	{
		m_lpDebugEpgDumpFunc = lpFunc;
		m_lpDebugEpgDumpContext = lpContext;
	}
#endif
	BOOL IsWindowVisible() { return ::IsWindowVisible(m_hWnd); }
	BOOL ShowWindow(int iShowMode) { return ::ShowWindow(m_hWnd,iShowMode); }

	BOOL Create(HINSTANCE hInst,int iResource,HWND hParentWnd,BOOL bNoPosSize,int x,int y,int sx,int sy,int iShowMode);
	void Destroy(int *pX ,int *pY,int *pSX,int *pSY,BOOL *pbShow);
	void SetEnable(BOOL bEnable);
	void DeleteAllItems();
	void AddService(WORD wServiceID,WORD wPmtPID);
	void SetPMT(WORD wServiceID,struct FILTWND_PMTITEM *pstPmtItem,int iNum);
	void SetServiceName(WORD wServiceID,char *pszChName);
	void SetEPG_PF(WORD wServiceID,struct TSEPG_PROGRAM *pstProg,BOOL bActual=FALSE);	
	void SetCurrentEPG(DateTime &stCurrentTime);

protected:
	HINSTANCE m_hInst;
	HWND m_hWnd;
	HMENU m_hMenu;
	LOCK_OBJ m_stLock;
	FiltWndServiceListMap m_Service;
	FiltWndPosToServiceIDMap m_PosToService;
#ifdef FILTWND_ENABLE_CURRENT_PROGRAM
	FiltWndProgramListMap m_Program;
#endif
	BOOL m_bPacketFilter;

	CTsEPGMgr m_EpgDB;

	PF_FILTERWND_GET_SERVICE_NAME *m_lpGetServiceNameFunc;
	LPVOID	m_lpGetServiceNameContext;

	PF_FILTERWND_SETFILTER *m_lpSetFilterFunc;
	LPVOID	m_lpSetFilterContext;

	PF_FILTERWND_SCHEDULE_BYTIME_CALLBACK *m_lpScheduleTimeFunc;
	LPVOID m_lpScheduleTimeContext;

	PF_FILTERWND_SCHEDULE_BYEVENTID_CALLBACK *m_lpScheduleEventIDFunc;
	LPVOID m_lpScheduleEventIDContext;

	LRESULT FilterDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
	void OnInitDialog();
	void OnSize();
	BOOL SetSubItem(WORD wServiceID,WORD wSubIndex,char *lpszText);
	void MakeEventStrings(DWORD dwFlags,char *lpszBuf,int iBufLen,DateTime &stStart,DateTime &stEnd,char *szTitle,char *szDetail,BYTE byVideoType,BYTE byAudioType);
	void MakeTipString(char *lpszBuf,int iBufLen,struct TSEPG_PROGRAM *pstProg);
	void CreateFilterList(WORD** ppwServiceList,int *piServiceNum,WORD **ppwPidList,int *piPidNum);
	void OnPacketFilterBtn(BOOL bForceOff=FALSE);
	BOOL OnRecSchedule(int iFlg);
	BOOL OnRecSchedule_ByEventID(int iFlg);
	BOOL OnShowEPG();
	void SetCurrentEPG_ServiceList(DateTime &stCurrentTime);
#ifdef FILTWND_ENABLE_CURRENT_PROGRAM
	void SetCurrentEPG_ProgramList(DateTime &stCurrentTime);
#endif

	// fobOp
#ifdef _DEBUG
	PF_FILTERWND_DEBUG_DUMPEPG_REQUEST_CALLBACK *m_lpDebugEpgDumpFunc;
	LPVOID m_lpDebugEpgDumpContext;
	void OnDebug();
#endif

#ifdef FILTWND_ENABLE_TIPWND
	// Tip֘A
	HWND m_hTip;
	FiltWndToolTip m_Tooltip;
	void UpdateToolTip(HWND hListView);
	// iK̑㕨B͎gĂȂ
	BOOL MousePt_to_ListViewItem(POINT ptMouse,int *piItem,int *piSubItem);
#endif
#ifdef FILTWND_ENABLE_CURRENT_PROGRAM
#ifdef FILTWND_ENABLE_TIPWND
	// Tip֘A
	HWND m_hTip_ProgramList;
	FiltWndToolTip m_Tooltip_Program;
	void UpdateToolTip_ProgramList(HWND hListView);
#endif
#endif

protected:
	// WindowProc(Dummy)
	static LRESULT CALLBACK _FilterDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
	{
	#pragma warning(disable: 4312)
		CFilterWnd* pThis=reinterpret_cast<CFilterWnd*>(GetWindowLongPtr(hDlg,GWL_USERDATA));
	#pragma warning(default: 4312)
		if(message==WM_INITDIALOG)
		{
			{
				pThis=(CFilterWnd*)lParam;
	#pragma warning(disable: 4244)
				SetWindowLongPtr(hDlg,GWL_USERDATA,reinterpret_cast<LONG_PTR>(pThis));
	#pragma warning(default: 4244)
			}
		}
		if(pThis)
		{
			return pThis->FilterDlg(hDlg,message,wParam,lParam);
		} else {
			return FALSE;
		}
	}
};
